package io.gmss.fiscad.implementations.rfu.metier;

import io.gmss.fiscad.entities.rfu.metier.UniteLogement;
import io.gmss.fiscad.exceptions.BadRequestException;
import io.gmss.fiscad.exceptions.NotFoundException;
import io.gmss.fiscad.interfaces.rfu.metier.UniteLogementService;
import io.gmss.fiscad.repositories.rfu.metier.UniteLogementRepository;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class UniteLogementServiceImpl implements UniteLogementService {

    private final UniteLogementRepository uniteLogementRepository;

    public UniteLogementServiceImpl(UniteLogementRepository uniteLogementRepository) {
        this.uniteLogementRepository = uniteLogementRepository;
    }

    @Override
    public UniteLogement createUniteLogement(UniteLogement uniteLogement) throws BadRequestException {
        if (uniteLogement.getId() != null) {
            throw new BadRequestException("Impossible de créer une nouvelle unité de logement ayant un id non null.");
        }
        return uniteLogementRepository.save(uniteLogement);
    }

    @Override
    public UniteLogement updateUniteLogement(Long id, UniteLogement uniteLogement) throws NotFoundException {
        if (uniteLogement.getId() == null) {
            throw new BadRequestException("Impossible de mettre à jour une nouvelle unité de logement ayant un id null.");
        }
        if (!uniteLogementRepository.existsById(uniteLogement.getId())) {
            throw new NotFoundException("Impossible de trouver la nouvelle unité de logement spécifiée dans notre base de données.");
        }
        return uniteLogementRepository.save(uniteLogement);
    }

    @Override
    public void deleteUniteLogement(Long id) throws NotFoundException {
        Optional<UniteLogement> uniteLogementOptional = uniteLogementRepository.findById(id);
        if (uniteLogementOptional.isPresent()) {
            uniteLogementRepository.deleteById(uniteLogementOptional.get().getId());
        } else {
            throw new NotFoundException("Impossible de trouver la nouvelle unité de logement spécifiée dans notre base de données.");
        }
    }

    @Override
    public Page<UniteLogement> getUniteLogementList(Pageable pageable) {
        return uniteLogementRepository.findAll(pageable);
    }

    @Override
    public List<UniteLogement> getUniteLogementList() {
        return uniteLogementRepository.findAll();
    }


    @Override
    public Optional<UniteLogement> getUniteLogementById(Long id) {
        if (uniteLogementRepository.existsById(id)) {
            return uniteLogementRepository.findById(id);
        } else {
            throw new NotFoundException("Impossible de trouver la nouvelle unité de logement spécifiée dans la base de données.");
        }

    }
}
